<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Sistema de ficheros distribuido en Java (JavaAFS)</title>
</head>
<body>

<h1>Sistema de ficheros distribuido en Java (JavaAFS)</h1>

Se trata de un proyecto práctico de desarrollo <b>en grupos de 2 personas</b>
cuyo plazo de entrega termina el <b>24 de mayo</b>.
<p>


</p><h2>Objetivo de la práctica</h2>
La práctica consiste en desarrollar un sistema de ficheros distribuido 
en un entorno Java que permita que el alumno llegue a conocer
de forma práctica el tipo de técnicas que se usan en estos sistemas,
tal como se estudió en la parte teórica de la asignatura.
<p>
Con respecto al sistema que se va a desarrollar,
se trata de un SFD basado en el modelo de carga/descarga, con una semántica
de sesión, con caché en los clientes almacenada en disco e invalidación
iniciada por el servidor. Es, por tanto, un sistema con unas características
similares al AFS estudiado en la parte teórica de la asignatura
Se recomienda, por tanto, que el alumno
revise el sistema de ficheros AFS en la documentación de la asignatura
antes de afrontar la práctica.
</p><p>
Evidentemente, dadas las limitaciones de este trabajo,
el sistema a desarrollar presenta enormes simplificaciones con respecto
a las funcionalidades presentes en un sistema AFS real, entre ellas:
</p><ul>
<li>Hay un único servidor.
</li><li>No hay directorios. Concretamente, el servidor (<i>vice</i>; directorio <tt>servidor</tt>) exportará solo los ficheros que se encuentran en el
directorio <tt>AFSdir</tt> (o sea, que si un cliente solicita el
fichero <tt>f</tt>, el servidor enviará el fichero <tt>AFSdir/f</tt>). Nótese que los ficheros pueden ser de texto o binarios.
</li><li>Se trata de un sistema monousuario, no existiendo el concepto
de permisos de acceso a un fichero (o sea, todos los ficheros son accesibles).
</li><li>Cada nodo "cliente" (<i>venus</i>; directorios <tt>cliente1</tt>, <tt>cliente2</tt>...) se corresponde con una JVM, pudiendo estas estar ejecutando en distintas máquinas.
</li><li>Las copias de los ficheros en el cliente se almacenan en un directorio llamado <tt>Cache</tt> dentro de cada nodo "cliente", y tendrán el mismo nombre que el del fichero.
</li><li>Se asume que las aplicaciones no son concurrentes y que no
va a haber sesiones de escritura
simultáneas sobre un mismo fichero aunque sí puede haber múltiples
sesiones de lectura mientras que se produce una de escritura.
</li><li>A las aplicaciones se les ofrece un API similar a la clase <tt>RandomAccessFile</tt> de Java, pero limitándose, para simplificar el trabajo, a las operaciones de lectura (<tt>read</tt>) y escritura (<tt>write</tt>) usando vectores de bytes, así como de modificación de la posición del puntero (<tt>seek</tt>) y de cambio de tamaño de un fichero (<tt>setLength</tt>). Se limita también los
modos de apertura posibles de un fichero a solo dos, manteniendo la misma semántica
que en <tt>RandomAccessFile</tt>:
<ul>
<li>Modo <tt>r</tt>: si el fichero existe se abre en modo lectura; en
caso contrario, se genera la excepción <tt>FileNotFoundException</tt>.
</li><li>Modo <tt>rw</tt>: si el fichero existe se abre en modo lectura/escritura; en
caso contrario, también se crea previamente.
</li></ul>
</li><li>Asimismo,
se usa la clase <tt>RandomAccessFile</tt> para el acceso interno, tanto
local como remoto, a los datos del fichero.
</li></ul>
<p>
En cuanto a la tecnología de comunicación usada en la práctica,
se ha elegido Java RMI (si no está familiarizado
con el uso de esta tecnología puede consultar esta <a href="http://laurel.datsi.fi.upm.es/~ssoo/SD.dir/practicas/guiarmi.html">
guía sobre la programación en Java RMI</a>).

</p><p>Para completar esta sección introductoria, se incluyen, a continuación,
dos fragmentos de código que permiten apreciar las diferencias
entre el API de acceso de lectura/escritura a un fichero local
usando la clase <tt>RandomAccessFile</tt>, en la que se inspira
el API planteado, y el correspondiente al
acceso remoto utilizando el servicio que se pretende desarrollar:

</p><hr>
<pre>// acceso local
try {
    RandomAccessFile f = new RandomAccessFile("fich", "rw");
    byte[] b = new byte[1024];
    leido = f.read(b);
    f.seek(0);
    f.write(b);
    f.setLength(512);
    f.close();
}
catch (FileNotFoundException e) {
    e.printStackTrace();
}
catch (IOException e) {
    e.printStackTrace();
}
</pre>
<hr>
<pre>// acceso remoto (en negrilla aparecen los cambios respecto a un acceso local)
try {
    // iniciación de la parte cliente
    <b>Venus venus = new Venus();</b>

    // apertura de un fichero;
    // el modo de apertura solo puede ser "r" o "rw"
    // y tiene el mismo comportamiento que en RandomAccessFile.
    // Si el fichero no está en la caché, se descarga del servidor
    // y se almacena en el directorio Cache.
    // Finalmente, se abre el fichero en Cache como un RandomAccessFile.
    <b>VenusFile f = new VenusFile(venus, "fich", "rw"); </b>

    // resto de las operaciones igual que en local;
    // de hecho, se realizan sobre la copia local
    byte[] b = new byte[1024];
    leido = f.read(b);
    f.seek(0);
    f.write(b);
    f.setLength(512);

    // si el fichero se ha modificado, se vuelca al servidor
    f.close();
}
catch (FileNotFoundException e) {
    e.printStackTrace();
}
catch (IOException e) {
    e.printStackTrace();
}
catch (Exception e) {
    e.printStackTrace();
}
</pre>
<hr>
<p>
Para afrontar el trabajo de manera progresiva,
se propone un desarrollo incremental en varias fases. Por cada
fase, se indicará qué funcionalidad desarrollar como parte de la misma
y qué pruebas concretas realizar para verificar el comportamiento
correcto del código desarrollado.
</p><ol>
<li>Acceso de lectura a un fichero remoto sin tener en cuenta aspectos de coherencia (valoración de 3 puntos).
</li><li>Acceso de escritura a un fichero remoto sin tener en cuenta aspectos de coherencia (valoración de 3 puntos).
</li><li>Incorporación de un modelo de coherencia asumiendo que solo 
puede haber una sesión de escritura, con múltiples de lectura, en cada 
momento (valoración de 4 puntos).
</li></ol>


<h2>Arquitectura del software del sistema</h2>
Antes de pasar a presentar cada una de las fases, se especifica en esta
sección qué distintos componentes hay en este sistema.
<p>
En primer lugar, hay que resaltar que
la práctica está diseñada para no permitir
la definición de nuevas clases (a no ser que se trate de clases
anidadas), estando todas ya presentes, aunque
mayoritariamente vacías, en el material de apoyo.
</p><p>
No todas ellas serán necesarias en las primeras fases de la
práctica, como se irá explicando en esta misma sección y a lo largo del
documento. Por tanto, no es necesario que entienda el objetivo de
cada clase en este punto, ya que se irá descubriendo a lo
largo de las sucesivas fases.
</p><p>
El software de la práctica está organizado en tres directorios: <tt>cliente</tt>
 (realmente, hay varios directorios cliente para asegurarse de que cada 
JVM tiene su propia caché si se ejecutan varios "nodos cliente" en la 
misma máquina
real), <tt>servidor</tt> y <tt>afs</tt>. Empecemos por este último, que contiene las
clases que proporcionan la funcionalidad del servicio a desarrollar, que
estarán incluidas en el paquete <tt>afs</tt>. A continuación, se comenta
brevemente el objetivo de cada una, que será posteriormente explicado
en detalle en las secciones del documento dedicadas a presentar progresivamente
la funcionalidad requerida.
</p><ul>
<li><tt>Venus</tt>: Clase de cliente que proporciona acceso al
servicio realizando la iniciación de la parte cliente. La aplicación
deberá instanciar un objeto de esta clase antes de interaccionar
con el servicio desarrollado. Esta clase se requerirá desde la primera fase de la práctica.
</li><li><tt>VenusFile</tt>: Clase de cliente que proporciona el API del servicio AFS, existiendo un objeto de esta clase por cada uno de los ficheros
a los que está accediendo la aplicación. La aplicación
deberá instanciar un objeto de esta clase para acceder a un fichero.
Esta clase se requerirá desde la primera fase de la práctica.
</li><li><tt>Vice y ViceImpl</tt>: Interfaz remota, y clase
que la implementa, que ofrece en el servidor el servicio AFS proporcionando
métodos remotos para iniciar la carga y descarga de ficheros. Al arrancar
el servicio, el servidor, que ya está programado, instancia y registra un objeto de esta clase.
Estas clases se requerirán desde la primera fase de la práctica.
</li><li><tt>ViceReader y ViceReaderImpl</tt>: Interfaz remota, y clase
que la implementa, que ofrece en el servidor los servicios para
completar la descarga de un fichero. Se creará una clase de este tipo
en el servidor cada vez que se produce una operación de descarga.
Estas clases se requerirán desde la primera fase de la práctica.
</li><li><tt>ViceWriter y ViceWriterImpl</tt>: Interfaz remota, y clase
que la implementa, que ofrece en el servidor los servicios para
completar la carga de un fichero. Se creará una clase de este tipo
en el servidor cada vez que se produce una operación de carga.
Estas clases se requerirán a partir de la segunda fase de la práctica.
</li><li><tt>VenusCB y VenusCBImpl</tt>: Interfaz remota, y clase
que la implementa, que ofrece en el cliente el servicio de <i>callback</i>
requerido para implementar el protocolo de coherencia.
Se instanciará un objeto de esta clase en la parte cliente al iniciarse
la interacción con el servicio.
Estas clases se requerirán solo en la tercera fase de la práctica.
</li><li><tt>LockManager</tt>: Clase de servidor que gestiona cerrojos
de lectura/escritura para sincronizar el acceso a un fichero.
Ya está implementada y <b>no debe modificarse</b>.
Se requerirá en la tercera fase de la práctica.
</li></ul>
Con respecto a los directorios <tt>cliente</tt>, en los mismos se encuentra la
clase <tt>Test</tt>, que es un programa interactivo que sirve para
probar la funcionalidad de la práctica, permitiendo que el usuario
pueda realizar operaciones de lectura, escritura, posicionamiento y
cambio de tamaño sobre ficheros.
Asimismo, este programa recibirá como
variables de entorno la siguiente información:
<ul>
<li>en qué máquina y por qué puerto está dando servicio
el proceso <tt>rmiregistry</tt> en las variables <tt>REGISTRY_HOST</tt> y <tt>REGISTRY_PORT</tt>,
respectivamente.
</li><li>el tamaño de bloque usado en las transferencias entre los clientes
y el servidor: <tt>BLOCKSIZE</tt>.
</li></ul>
Mediante el uso de enlaces simbólicos, los directorios de cliente comparten
todos los ficheros (excepto, evidentemente, el directorio
<tt>Cache</tt>), no habiendo que realizar ningún desarrollo de
código en los mismos a no ser que uno quiera preparar sus propios
programas de prueba.
<p>
En cuanto al directorio <tt>servidor</tt>, donde tampoco
hay que hacer ningún desarrollo, este incluye la clase
<tt>ServidorAFS</tt> que inicia el servicio dándole de alta en el
<tt>rmiregistry</tt> con el nombre <tt>AFS</tt> (instancia
un objeto de la clase <tt>ViceImpl</tt> y lo registra). Este programa
recibe como argumento el número de puerto por el que escucha
el proceso <tt>rmiregistry</tt> previamente activado.
Este directorio contiene un subdirectorio denominado <tt>AFSDir</tt>
que será donde se ubiquen los ficheros del servidor.
</p><p>
Además de las diversas clases, en los distintos directorios se incluyen
<i>scripts</i> para facilitar la compilación de las clases y la ejecución
de los programas, así como la distribución de las clases requeridas
por el cliente y el servidor, en forma de ficheros JAR, teniendo en
cuenta que estos pueden residir en distintas máquinas.

</p><h2>Ejecución de la práctica</h2>
Aunque para toda la gestión del ciclo de desarrollo del 
código de la práctica se puede usar el IDE que se considere oportuno, para aquellos que prefieran no utilizar
una herramienta de este tipo, se proporcionan una serie de <i>scripts</i>
que permiten realizar toda la labor requerida. En esta sección, se
explica cómo trabajar con estos <i>scripts</i>.
<p>
Para probar la práctica, debería, en primer lugar, compilar
todo el código desarrollado que se encuentra en el directorio, y paquete,
<tt>afs</tt>, generando los ficheros JAR requeridos por el cliente
y el servidor.
</p><pre>cd afs
./compila_y_construye_JARS.sh
</pre>
A continuación, hay que compilar y ejecutar el servidor, activando
previamente <tt>rmiregistry</tt>.
<pre>cd servidor
./compila_servidor.sh
./arranca_rmiregistry 12345 &amp;
./ejecuta_servidor.sh 12345
</pre>
Por último, hay que compilar y ejecutar el cliente de prueba.
<pre>cd cliente1
./compila_test.sh
export REGISTRY_HOST=triqui3.fi.upm.es
export REGISTRY_PORT=12345
export BLOCKSIZE=... # el tamaño que considere oportuno
./ejecuta_test.sh
</pre>
Nótese que el servidor y el cliente pueden ejecutarse en distintas
máquinas. Además, tenga en cuenta que, si ejecuta varios clientes
en la misma máquina, debería hacerlo en diferente directorio de
cliente (<tt>cliente1</tt>, <tt>cliente2</tt>...).

<h2>Fase 1: lectura de un fichero sin tener en cuenta aspectos de coherencia</h2>
El objetivo de esta fase es permitir el acceso de lectura a ficheros
remotos almacenados en el servidor
(ubicados en el subdirectorio <tt>AFSDir</tt>).
<p>
Antes de pasar a describir la funcionalidad de esta fase, se considera
conveniente hacer dos reflexiones previas:
</p><ul>
<li>Dado que los ficheros pueden tener un tamaño considerable, no
es factible implementar un método remoto para descargar un fichero
que retornara el contenido del mismo, puesto que eso requeriría que
tanto en el cliente como en el servidor se almacenara en memoria todo
el fichero. Nótese que esa misma circunstancia se produce en la operación
de carga. Será necesario, por tanto, ir enviando el contenido del fichero
por bloques.
</li><li>Obsérvese que el modelo de RPC/RMI síncrono de Java RMI no es el
idóneo para este tipo de transferencias puesto que requiere
una interacción cliente/servidor (la invocación de un método remoto
que implica una petición y una respuesta) por cada bloque involucrado.
</li></ul>
<h3>Fase 1: funcionalidad del servidor</h3>
Para realizar la descarga, se plantea usar un
esquema de fábrica de referencias remotas a objetos (véase en la <a href="http://laurel.datsi.fi.upm.es/~ssoo/SD.dir/practicas/guiarmi.html">guía de Java RMI</a> la sección dedicada a este esquema),
tal que se cree un objeto remoto para encapsular cada sesión de descarga de un fichero.
Con este esquema, el servicio <tt>Vice</tt> ofrece una
operación (<tt>download</tt>) para iniciar la descarga de un fichero
que genera una referencia remota de tipo <tt>ViceReader</tt>
que ofrece métodos remotos para ir descargando el fichero bloque a bloque.
<p>
En <tt>ViceReaderImpl</tt> se usará la clase <tt>RandomAccessFile</tt>
para los accesos al fichero real. De hecho, cada objeto <tt>ViceReaderImpl</tt>
almacenará internamente un objeto <tt>RandomAccessFile</tt> que corresponderá
a la sesión de acceso de lectura del fichero.
</p><p>A continuación, se detallan los cambios a realizar:
</p><ul>
<li>En el método <tt>download</tt> de la clase <tt>ViceImpl</tt> se creará una instancia de la clase <tt>ViceReaderImpl</tt> que se retornará como
resultado del método. El cliente usará los métodos remotos de esta clase
para completar la descarga.
</li><li>En cuanto a la clase <tt>ViceReaderImpl</tt>, en el constructor
se debería instanciar un objeto de la clase <tt>RandomAccessFile</tt>
asociado al fichero en el servidor (es decir, <i>abrir el fichero</i>) y en los métodos
remotos de acceso al fichero se debería invocar el método correspondiente de <tt>RandomAccessFile</tt>.
</li><li>Como parte del desarrollo, tendrá que realizar los <tt>imports</tt>
requeridos (por ejemplo, de <tt>java.io</tt>), así como la propagación
de las excepciones (<tt>throws</tt>) pertinentes. Así, por ejemplo, tanto
el constructor de <tt>ViceReaderImpl</tt> como el método <tt>download</tt>
que activa este constructor deben propagar la excepción <tt>FileNotFoundException</tt> que generará la clase <tt>RandomAccessFile</tt> si el fichero no
existe, para que, de esta forma, el cliente sea notificado de esta circunstancia.
</li></ul>
Para terminar esta sección, se considera conveniente realizar una aclaración sobre el método remoto <tt>read</tt>. De forma intutiva, parecería más
razonable usar una declaración similar a la del método del mismo nombre
de la clase <tt>RandomAccessFile</tt> permitiendo de esta forma
una implementación directa del mismo:
<pre>    public int read(byte[] b) throws ...
        return f.read(b); // siendo f un objeto de tipo RandomAccessFile
    }
</pre>
Sin embargo, este modo de operación no es correcto en Java RMI
ya que este método remoto devolvería la información leída en un parámetro
pasado por referencia y Java RMI no permite ese tipo de paso de información
(véase la <a href="http://laurel.datsi.fi.upm.es/~ssoo/SD.dir/practicas/guiarmi.html">
guía sobre la programación en Java RMI</a> para profundizar sobre este tema). 
Es por ello que en la definición propuesta la información leída
se devuelve como retorno del método remoto.
<h3>Fase 1: funcionalidad del cliente</h3>
Con respecto a la parte cliente, en esta fase entran en juego dos clases:
<ul>
<li><tt>Venus</tt>: esta clase corresponde a la iniciación de la interacción
de una aplicación con el servicio proporcionado y encapsula todo lo que
tiene que ver con la operación de búsqueda del
servicio <tt>AFS</tt> en el <tt>rmiregistry</tt> (es decir, el acceso a las tres variables de entorno previamente descritas, <tt>REGISTRY_HOST</tt>, <tt>REGISTRY_PORT</tt> y <tt>BLOCKSIZE</tt>, y la propia operación de <i>lookup</i>) para evitar de esta forma
que se tenga que realizar este proceso por cada fichero accedido por
la aplicación. Esta clase ofrecerá esta información a la clase
<tt>VenusFile</tt>, ya sea a través de atributos públicos o métodos
de tipo <i>getter</i>.
</li><li><tt>VenusFile</tt>: habrá un objeto de este tipo por cada fichero
abierto por la aplicación. El constructor deberá comprobar si el
fichero existe en <tt>Cache</tt> y, en caso negativo, deberá proceder
a su descarga del servidor usando los métodos remotos (primero,
usará la referencia remota obtenida por <tt>Venus</tt> para iniciar
la descarga y, a continuación, utilizará los métodos remotos
del objeto <tt>ViceReader</tt> creado en el servidor para completarla descargando el fichero bloque a bloque usando el tamaño especificado en la
variable de entorno correspondiente) y almacenando
el contenido en una copia local en el directorio <tt>Cache</tt>. El
constructor debe dejar abierto el fichero local, existiera
este desde el principio o no. Con respecto a los métodos de esta clase,
trabajarán directamente sobre el fichero local.
</li></ul>
<h3>Fase 1: pruebas</h3>
En esta sección se comentan qué pruebas se pueden llevar a cabo para verificar
la funcionalidad pedida.
<ol>
<li>Arranque el programa <tt>Test</tt> y abra un fichero no existente
en el servidor. El programa <tt>Test</tt> debería imprimir el
mensaje <tt>Fichero no existente</tt> lo que significaría que ha recibido
la excepción <tt>FileNotFoundException</tt> que se ha propagado desde
el servidor hasta la aplicación.
</li><li>Arranque el programa <tt>Test</tt> y abra un fichero que previamente
ha creado en el servidor de forma externa a la práctica y que ocupe más de un bloque teniendo
un tamaño que no sea múltiplo del tamaño de bloque. Use las
operaciones <tt>read</tt> y <tt>seek</tt> del programa de prueba
para comprobar que el contenido es correcto.
</li><li>Siguiendo con la prueba anterior, queremos probar ahora que cuando
el fichero existe en <tt>Cache</tt> se usa la copia local. Para verificarlo,
cierre el fichero, modifique externamente alguna parte del contenido
de la copia del fichero en <tt>Cache</tt> y compruebe que al volver
a abrirlo se accede al contenido modificado y no al servidor.
</li><li>Como última prueba, compruebe el comportamiento del código desarrollado
si se lee un fichero existente pero vacío.
</li></ol>
<h2>Fase 2: Escritura en un fichero sin tener en cuenta aspectos de coherencia</h2>
Una operación de escritura en un fichero puede implicar una operación de descarga,
al abrirlo si no está en <tt>Cache</tt>, y una de carga, al cerrarlo
si se ha escrito o se ha cambiado su tamaño durante la sesión de acceso.
<p>
Aunque la operación de carga ya se ha implementado en la fase previa,
habrá que reajustarla dado el diferente comportamiento de la operación
de apertura de un fichero dependiendo del modo de apertura en caso de que este no exista previamente: en una sesión
de lectura (modo <tt>r</tt>) se produce la excepción <tt>FileNotFoundException</tt>,
mientras que en una de escritura (modo <tt>rw</tt>) el fichero se crea y
se abre normalmente.
</p><h3>Fase 2: funcionalidad del servidor</h3>
Revisemos los cambios requeridos en las distintas clases:
<ul>
<li>En <tt>ViceImpl</tt> habrá que programar el
método <tt>upload</tt> para que cree una instancia de la clase <tt>ViceWriterImpl</tt> que se retornará como
resultado del método. El cliente usará los métodos remotos de esta clase
para completar la carga.
</li><li>Con respecto a la clase <tt>ViceReaderImpl</tt>, habrá que reajustar su
constructor para tener en cuenta el modo de apertura
tal como se ha explicado previamente.
</li><li>En cuanto a la clase <tt>ViceWriterImpl</tt>, en el constructor
se debería instanciar un objeto de la clase <tt>RandomAccessFile</tt>
asociado al fichero en el servidor y en los métodos
remotos de acceso al fichero se debería invocar el método correspondiente de <tt>RandomAccessFile</tt>.
</li><li>Como parte del desarrollo, tendrá que realizar los <tt>imports</tt>
y la propagación de las excepciones requeridos.
</li></ul>

<h3>Fase 2: funcionalidad del cliente</h3>
Con respecto a la parte cliente, los cambios requeridos serían:
<ul>
<li><tt>VenusFile</tt>: habrá que controlar si se modifica o se cambia de
tamaño el fichero durante la sesión de acceso de manera que, si ocurre
esta circunstancia, en la operación de cierre se realice la carga
del fichero al sevidor: primero,
usará la referencia remota obtenida por <tt>Venus</tt> para iniciar
la carga y, a continuación, utilizará los métodos remotos
del objeto <tt>ViceWriter</tt> creado en el servidor para completarla enviando
el contendo del fichero bloque a bloque.
</li></ul>
<h3>Fase 2: pruebas</h3>
En primer lugar, se debería comprobar que las pruebas de la fase anterior
siguen funcionando correctamente. Estas serían las pruebas propuestas
para esta fase:
<ol>
<li>Pruebe a abrir en modo lectura un fichero existente y, a continuación,
escriba en el mismo. El programa de prueba debería imprimir que se ha producido
una excepción de E/S y continuar operando correctamente.
</li><li>Repita la prueba anterior cambiando la longitud del fichero.
</li><li>Abra un fichero no existente en modo escritura, escriba en el mismo
y ciérrelo. Compruebe que tanto el contenido almacenado
en <tt>Cache</tt> como en <tt>AFSDir</tt> es correcto.
</li><li>Abra un fichero existente en modo escritura, escriba en el mismo
y ciérrelo. Compruebe que tanto el contenido almacenado
en <tt>Cache</tt> como en <tt>AFSDir</tt> es correcto.
</li><li>Repita la prueba anterior cambiando solo la longitud del fichero.
</li><li>Pruebe el uso de la caché haciendo dos sesiones sucesivas de
escritura sobre un fichero existente.
</li></ol>

<h2>Fase 3: Implementación del modelo de coherencia</h2>
En esta fase se aborda el protocolo de coherencia de AFS pero solo
para un escenario simplificado donde se asume que en cada momento
solo hay una sesión de escritura activa en cada fichero, que, eso sí, 
podría ejecutarse concurrente con sesiones de lectura simultáneas sobre 
ese mismo
fichero.
<p>Antes de pasar a describir la funcionalidad concreta de esta fase, hay
que revisar dos aspectos relacionados con los problemas de coherencia
debido a accesos simultáneos.
</p><h3>Sincronización de cargas y descargas</h3>
Tal como se han implementado las fases previas se pueden producir en
paralelo cargas y descargas de un mismo fichero, lo que puede causar
problemas de coherencia (el lector puede realizar una descarga parcial
de un fichero porque el escritor todavía no ha completado la carga).
<p>
La solución más directa es usar cerrojos de lectura/escritura sobre
un fichero mientras se está descargando (cerrojo de lectura) o cargando
(cerrojo de escritura), permitiendo, de esta forma, un modelo
de múltiples descargas pero solo una carga. Habría que solicitar un
bloqueo de un cerrojo de lectura al principio de la descarga para
liberarlo al final de la misma y uno de escritura siguiendo la misma
pauta para la carga.
</p><p>
Java ofrece esta funcionalidad dentro de la clase <tt>FileLock</tt>, que se basa
en el mecanismo nativo equivalente del sistema operativo subyacente.
Sin embargo, este mecanismo no es aplicable al problema de sincronización
planteado, puesto que los accesos que se requiere sincronizar corresponden a <i>threads</i>
del mismo proceso (Java RMI va asignando <i>threads</i> para que 
procesen
concurrentemente las peticiones que se van recibiendo), mientras que
este mecanismo es solo válido para sincronizar procesos independientes
(nótese que sucede lo mismo con los cerrojos de ficheros convencionales 
de Linux, aunque en este sistema operativo existe una variedad que sí 
sería
válida: los <i>Open file description locks</i>, que quedan fuera de este
proyecto práctico).
</p><p>
Para solventar esta limitación, vamos a usar un mecanismo 
de sincronización no vinculado con los ficheros, como son los <i>mutex</i>
de lectura y escritura que ofrece Java.
En el código de apoyo de la práctica se ofrece una clase denominada
<tt>LockManager</tt>, que será instanciada por <tt>ViceImpl</tt>, y que ofrece esta funcionalidad permitiendo
asociar un nombre (el fichero) con un mutex de lectura/escritura:
</p><ul>
<li>Método <tt>bind</tt>: retorna un mutex de lectura/escritura
(<tt>ReentrantReadWriteLock</tt>) asociado a ese nombre (a ese
fichero): si ya existe, solo lo devuelve; en caso contrario, lo
crea previamente. Recuerde que la clase <tt>ReentrantReadWriteLock</tt>,
que corresponde al mutex retornado, ofrece los métodos:
<ul>
<li><tt>readLock().lock()</tt>: solicitud de un bloqueo de lectura.
</li><li><tt>readLock().unlock()</tt>: eliminación de un bloqueo de lectura.
</li><li><tt>writeLock().lock()</tt>: solicitud de un bloqueo de escritura.
</li><li><tt>writeLock().unlock()</tt>: eliminación de un bloqueo de escritura.
</li></ul>
</li><li>Método <tt>unbind</tt>: indica que se ha dejado de usar por parte
de un <i>thread</i> el mutex de lectura/escritura asociado a ese nombre.
</li></ul>
<h3>Protocolo de coherencia</h3>
Recuerde que el protocolo de coherencia de AFS conlleva que cuando
se carga una nueva copia de un fichero al servidor, que ocurrirá
al final de una sesión de escritura donde la aplicación ha modificado
el contenido del fichero o su longitud, hay que invalidar todas
las demás copias de las cachés de los clientes, tengan estos el
fichero abierto (nótese que en esta fase si lo tienen abierto debe
ser para una sesión de lectura) o no.
<p>
En la práctica, la invalidación de la copia del fichero en la caché
se realizará directamente borrando el fichero del directorio <tt>Cache</tt>,
lo que hará que posteriores accesos a ese fichero no lo encuentren en
la caché y tengan que descargarlo del servidor.
Recuerde que, dado como implementa el sistema operativo el acceso a los
ficheros, aunque se borre el fichero de <tt>Cache</tt>, las sesiones de acceso a ese fichero
que ya estén activas localmente continuarán sin incidencias.
</p><p>
Para implementar el mecanismo de invalidaciones se usará un esquema
de tipo <i>callback</i>
(véase la <a href="http://laurel.datsi.fi.upm.es/~ssoo/SD.dir/practicas/guiarmi.html">
guía sobre la programación en Java RMI</a> para profundizar sobre este tema),
que permite a un servidor invocar un método remoto de un cliente.
El modo de operación será el siguiente:
</p><ul>
<li>El objeto de la clase <tt>Venus</tt> instanciará un objeto de la clase <tt>VenusCBImpl</tt>, que implementará el mecanismo de <i>callback</i>. Este
objeto simplemente implementará la invalidación (método <tt>invalidate</tt>) borrando el fichero de la caché.
</li><li>Las invocaciones en <tt>VenusFile</tt> a los métodos de carga y descarga
enviarán al servidor una referencia a ese objeto de tipo <i>callback</i>.
</li><li>La clase <tt>ViceImpl</tt> en el servidor gestionará una estructura de
datos que asocie cada nombre de fichero con los objetos de <i>callback</i> de los clientes
que tienen copias del fichero en su caché.
</li><li>Cada vez que un cliente descarga un fichero se añade su <i>callback</i>
a la estructura de datos.
</li><li>Cada vez que un cliente carga un fichero se invoca el método de
invalidación de todos los demás clientes (nótese la existencia del
método <tt>equals</tt> para comprobar la igualdad entre dos objetos
de tipo <i>callback</i>) y se eliminan de la lista, puesto que esos
clientes ya no tienen copia.
</li></ul>

<h3>Fase 3: funcionalidad del servidor</h3>
Esta funcionalidad requiere los siguientes cambios en las clases de servidor:
<ul>
<li>En <tt>ViceImpl</tt> (y en <tt>Vice</tt>) añadir la referencia al
<i>callback</i> como parámetro de los métodos <tt>download</tt>
y <tt>upload</tt>. Asimismo, dado que va a ser necesario acceder a
funcionalidad de esta clase desde <tt>ViceReaderImpl</tt> y <tt>ViceWriterImpl</tt>, sería conveniente pasar una referencia de <tt>ViceImpl</tt> (<tt>this</tt>) en los constructores de <tt>ViceReaderImpl</tt> y <tt>ViceWriterImpl</tt>
(dependiendo de cómo se implemente la funcionalidad de esta fase, también
podría ser conveniente pasar una referencia al <i>callback</i>).
</li><li>Asimismo, en <tt>ViceImpl</tt> habrá que instanciar el <tt>LockManager</tt>
y definir una estructura que relacione nombres de fichero con listas
de <tt>callbacks</tt>, así como los métodos que se requieran para la gestión
de esta estructura. Nótese que, dado que se pueden producir accesos
concurrentes a esta estructura de datos (por ejemplo, descargas
en paralelo de dos ficheros distintos), habrá que asegurar la coherencia
de esta estructura usando, si es necesario, métodos <tt>synchronized</tt>
para la gestión de la misma.
</li><li>En <tt>ViceReaderImpl</tt>, que tendrá nuevos parámetros en su constructor,
habrá que pedir al <tt>LockManager</tt> un cerrojo asociado al fichero solicitando un bloqueo de lectura
e incorporar el <tt>callback</tt> en la lista asociada a ese fichero
(esta operación también se podría realizar en el propio método <tt>download</tt>). En el método <tt>close</tt> habrá que liberar el cerrojo e informar
de que ya no se requiere el uso de ese cerrojo.
</li><li>Los cambios en <tt>ViceWriterImpl</tt> serán similares exceptuando dos
aspectos. Por un lado, las operaciones sobre el cerrojo son de escritura.
Por otro lado, cuando se completa la descarga, pero antes de liberar el
cerrojo, hay que invocar al método <tt>invalidate</tt> de cada objeto
de tipo <i>callback</i> asociado a este fichero, exceptuando únicamente
el correspondiente al cliente que está realizando la descarga (no queremos
invalidar esa copia porque corresponde precisamente con la nueva versión
del fichero).
</li></ul>

<h3>Fase 3: funcionalidad del cliente</h3>
En cuanto a la parte cliente, requiere los siguientes cambios:
<ul>
<li>En <tt>Venus</tt> hay que instanciar el <i>callback</i>.
</li><li>En <tt>VenusFile</tt> se tiene que pasar el <i>callback</i> como
parámetro en los métodos que inician la carga y la descarga.
</li><li>En <tt>VenusCB</tt> hay que implementar el método de invalidación
que borrará el fichero de <tt>Cache</tt>.
</li></ul>

<h3>Fase 3: pruebas</h3>
Para probar el protocolo de coherencia puede ejecutar la siguiente secuencia
de procesos:
<ol>
<li>En <tt>cliente1</tt> abra un fichero no existente en modo <tt>rw</tt>,
escríbalo y ciérrelo.
</li><li>En <tt>cliente2</tt> abra ese fichero en modo <tt>r</tt>,
léalo y ciérrelo.
</li><li>En <tt>cliente3</tt> abra ese fichero en modo <tt>r</tt> y lea parte
del mismo pero no lo cierre.
</li><li>En <tt>cliente4</tt> abra ese fichero en modo <tt>rw</tt>,
y modifique parte del mismo. Antes de cerrarlo, compruebe el contenido
de los directorios <tt>Cache</tt> de los cuatro clientes y del directorio
<tt>AFSDir</tt> del servidor. Las copias en los tres primeros clientes
deben ser iguales que la del servidor puesto que todavía no se
ha cerrado el fichero en el cuarto cliente.
</li><li>Cierre el fichero en el cuarto cliente. En ese momento, tienen que
haber desaparecido las copias de los tres primeros clientes y la
copia del cuarto debe ser igual que la del servidor.
</li><li>Solicite una nueva lectura en <tt>cliente3</tt> y pruebe a leer
con el descriptor obtenido en la primera apertura que todavía no
se cerró y con el nuevo. Verifique que con el primero se accede al
contenido original mientras que con el segundo al nuevo.
</li></ol>


<h2>Material de apoyo de la práctica</h2>
El material de apoyo de la práctica se encuentra en este
<a href="http://laurel.datsi.fi.upm.es/~ssoo/SD.dir/practicas/javaAFS.tgz">enlace</a>.
<p>
Al descomprimir el material de apoyo se crea el entorno de desarrollo de la práctica, que
reside en el directorio: <tt>$HOME/DATSI/SD/javaAFS.2020/</tt>.



</p><h2>Entrega de la práctica</h2>

Se realizará en la máquina <tt>triqui</tt>, usando el mandato:

<pre>entrega.sd javaAFS.2020
</pre>

<p>
Este mandato recogerá los siguientes ficheros:

</p><ul>
<li><tt>autores</tt>
Fichero con los datos de los autores:
<pre>DNI APELLIDOS NOMBRE MATRÍCULA
</pre>

</li><li><tt>memoria.txt</tt>
Memoria de la práctica. En ella se pueden comentar los aspectos del
desarrollo de su práctica que considere más relevantes.
Asimismo, puede exponer los comentarios personales que considere
oportuno.

</li><li><tt>afs/Venus.java</tt>
</li><li><tt>afs/VenusFile.java</tt>
</li><li><tt>afs/VenusCB.java</tt>
</li><li><tt>afs/VenusCBImpl.java</tt>
</li><li><tt>afs/Vice.java</tt>
</li><li><tt>afs/ViceImpl.java</tt>
</li><li><tt>afs/ViceReader.java</tt>
</li><li><tt>afs/ViceReaderImpl.java</tt>
</li><li><tt>afs/ViceWriter.java</tt>
</li><li><tt>afs/ViceWriterImpl.java</tt>
</li></ul>






</body></html>